/*
 * Copyright (C) Sergey P. Derevyago, 2008-2009.
 *
 * Permission to copy, use, modify, sell and distribute this software is granted
 * provided this copyright notice appears in all copies.
 * This software is provided "as is" without express or implied warranty, and
 * with no claim as to its suitability for any purpose.
 *
 */

/** @file
 * Defines macro hard_assert().
 */

#ifndef __DERS__HARD_ASRT_HPP__
#define __DERS__HARD_ASRT_HPP__

#include <ders/config.hpp>

namespace ders {  // ::ders

namespace detail {  // ::ders::detail

void hard_assert_impl(const char* expr, const char* file, int line);

}  // namespace ::ders::detail

}  // namespace ::ders

/**
 * Hard assertion that doesn't get disabled.
 */
#define hard_assert(expr) \
  ((expr) ? (void)0 : ders::detail::hard_assert_impl(#expr, __FILE__, __LINE__))

#endif  // __DERS__HARD_ASRT_HPP__

