/*
 * Copyright (C) Sergey P. Derevyago, 2008.
 *
 * Permission to copy, use, modify, sell and distribute this software is granted
 * provided this copyright notice appears in all copies.
 * This software is provided "as is" without express or implied warranty, and
 * with no claim as to its suitability for any purpose.
 *
 */

/** @file
 * Defines set of functions for memory searching.
 */

#ifndef __DERS__MEM_HPP__
#define __DERS__MEM_HPP__

#include <ders/config.hpp>

namespace ders {  // ::ders

void* mem_find(void* p1, int sz1, char ch);
const void* mem_find(const void* p1, int sz1, char ch);
void* mem_rev_find(void* p1, int sz1, char ch);
const void* mem_rev_find(const void* p1, int sz1, char ch);

void* mem_find(void* p1, int sz1, const void* p2, int sz2);
const void* mem_find(const void* p1, int sz1, const void* p2, int sz2);
void* mem_rev_find(void* p1, int sz1, const void* p2, int sz2);
const void* mem_rev_find(const void* p1, int sz1, const void* p2, int sz2);

inline const void* mem_find(const void* p1, int sz1, char ch)
{ return mem_find(const_cast<void*>(p1), sz1, ch); }

inline const void* mem_rev_find(const void* p1, int sz1, char ch)
{ return mem_rev_find(const_cast<void*>(p1), sz1, ch); }

inline const void* mem_find(const void* p1, int sz1, const void* p2, int sz2)
{ return mem_find(const_cast<void*>(p1), sz1, p2, sz2); }

inline const void* mem_rev_find(const void* p1, int sz1, const void* p2, int
  sz2)
{ return mem_rev_find(const_cast<void*>(p1), sz1, p2, sz2); }

}  // namespace ::ders

#endif  // __DERS__MEM_HPP__

