/*
 * Copyright (C) Sergey P. Derevyago, 2008.
 *
 * Permission to copy, use, modify, sell and distribute this software is granted
 * provided this copyright notice appears in all copies.
 * This software is provided "as is" without express or implied warranty, and
 * with no claim as to its suitability for any purpose.
 *
 */

/** @file
 * Implements macro hard_assert().
 */

#include <ders/hard_asrt.hpp>
#include <stdio.h>
#include <stdlib.h>

namespace ders {  // ::ders

namespace detail {  // ::ders::detail

void hard_assert_impl(const char* expr, const char* file, int line)
{
 fprintf(stderr, "\nHard assertion failed: %s, file %s, line %d\n", expr, file,
   line);
 abort();
}

}  // namespace ::ders::detail

}  // namespace ::ders

