/*
 * Copyright (C) Sergey P. Derevyago, 2008-2009.
 *
 * Permission to copy, use, modify, sell and distribute this software is granted
 * provided this copyright notice appears in all copies.
 * This software is provided "as is" without express or implied warranty, and
 * with no claim as to its suitability for any purpose.
 *
 */

/** @file
 * Implements class @link ders::hash_vec hash_vec @endlink.
 */

#include <ders/hash_vec.hpp>

namespace ders {  // ::ders

namespace detail {  // ::ders::detail

size_t calc_hash(const void* ptr, int n)
{
 assert(n>=0);

 size_t ret=0;
 for (const unsigned char *beg=static_cast<const unsigned char*>(ptr),
      *end=beg+n; beg!=end; beg++)
     ret=ret*5+*beg;

 return ret;
}

}  // namespace ::ders::detail

}  // namespace ::ders

