/*
 * Copyright (C) Sergey P. Derevyago, 2008-2009.
 *
 * Permission to copy, use, modify, sell and distribute this software is granted
 * provided this copyright notice appears in all copies.
 * This software is provided "as is" without express or implied warranty, and
 * with no claim as to its suitability for any purpose.
 *
 */

/** @file
 * Implements class @link ders::text_buf text_buf @endlink.
 */

#include <ders/text_buf.hpp>
#include <stdio.h>

namespace ders {  // ::ders

text_buf& text_buf::operator+(int val)
{
 char buf[25];
 return *this+ch_rng(buf, buf+sprintf(buf, "%d", val));
}

text_buf& text_buf::operator+(unsigned val)
{
 char buf[25];
 return *this+ch_rng(buf, buf+sprintf(buf, "%u", val));
}

text_buf& text_buf::operator+(long val)
{
 char buf[50];
 return *this+ch_rng(buf, buf+sprintf(buf, "%ld", val));
}

text_buf& text_buf::operator+(unsigned long val)
{
 char buf[50];
 return *this+ch_rng(buf, buf+sprintf(buf, "%lu", val));
}

text_buf& text_buf::operator+(void* ptr)
{
 char buf[25];
 return *this+ch_rng(buf, buf+sprintf(buf, "%p", ptr));
}

}  // namespace ::ders

