/*
 * Copyright (C) Sergey P. Derevyago, 2008.
 *
 * Permission to copy, use, modify, sell and distribute this software is granted
 * provided this copyright notice appears in all copies.
 * This software is provided "as is" without express or implied warranty, and
 * with no claim as to its suitability for any purpose.
 *
 */

/** @file
 * Implements singlethreaded function new_thread_pool().
 */

#include <ders/thread_pool.hpp>

namespace {

using namespace ders;
using namespace std;

struct st_thrpl : thread_pool, task_opers {
       bool stp;

       st_thrpl() {}

       virtual void destroy(mem_pool& mp2) { destroy_this(this, mp2); }
       virtual void exec(task& tk, const dq_vec& dv);
       virtual void invoke(void (*fun)(void*), void* arg);
};

void st_thrpl::exec(task& tk, const dq_vec& dv)
{
 mem_pool mp;
 try { tk.proc(mp, dv, tk.proc_arg(), *this); }
 catch (...) { hard_assert(false); }
}

void st_thrpl::invoke(void (*fun)(void*), void* arg)
{
 fun(arg);
}

}  // unnamed

namespace ders {  // ::ders

sh_thread_pool new_thread_pool(mem_pool& mp)
{
 mp_newbuf<st_thrpl> buf(mp);
 return sh_thread_pool(buf.pool(), buf.rls(::new(buf.get()) st_thrpl));
}

}  // namespace ::ders

