/*
 * Copyright (C) Sergey P. Derevyago, 2008.
 *
 * Permission to copy, use, modify, sell and distribute this software is granted
 * provided this copyright notice appears in all copies.
 * This software is provided "as is" without express or implied warranty, and
 * with no claim as to its suitability for any purpose.
 *
 */

/** @file
 * Internal file test.
 */

#include <ders/file.hpp>

using namespace ders;

int main(int argc, char** argv)
{
 mem_pool mp;
 file out(mp, fd::out);
 file err(mp, fd::err);

 shException error(mp, 0);
 try {
     if (argc!=3) {
        err.write("tst_file fin fout\n");
        return 1;
     }

     file fin(mp, argv[1], file::rdo, 0);
     buf_reader br(mp, fin);

     file fout(mp, argv[2], file::wro, file::crt|file::trnc);
     buf_writer bw(mp, fout);

     for (int ch; ; ) {
         if ((ch=br.read())==-1) {
            fin.ex_is_ok();
            break;
         }

         if (bw.write(ch)==-1) fout.ex_is_ok();
     }

     if (!bw.flush()) fout.ex_is_ok();

     return 0;
 }
 catch (shException she) { error=she; }
 catch (...) { error=recatchException(mp, _FLINE_); }

 err.write(toTextAll(error));
 return 1;
}

